import { top, left, right, bottom } from '../enums';
import getBasePlacement from '../utils/getBasePlacement';
import getMainAxisFromPlacement from '../utils/getMainAxisFromPlacement';
import getAltAxis from '../utils/getAltAxis';
export function preventOverflow(state, options) {
  if (options === void 0) {
    options = {};
  }

  var _options = options,
      _options$mainAxis = _options.mainAxis,
      checkMainAxis = _options$mainAxis === void 0 ? true : _options$mainAxis,
      _options$altAxis = _options.altAxis,
      checkAltAxis = _options$altAxis === void 0 ? false : _options$altAxis;
  var overflow = state.modifiersData.detectOverflow;
  var basePlacement = getBasePlacement(state.placement);
  var mainAxis = getMainAxisFromPlacement(basePlacement);
  var altAxis = getAltAxis(mainAxis);
  var popperOffsets = state.offsets.popper;

  if (checkMainAxis) {
    var mainSide = mainAxis === 'y' ? top : left;
    var altSide = mainAxis === 'y' ? bottom : right;
    state.offsets.popper[mainAxis] = Math.max(Math.min(popperOffsets[mainAxis], popperOffsets[mainAxis] - overflow[altSide]), popperOffsets[mainAxis] + overflow[mainSide]);
  }

  if (checkAltAxis) {
    var _mainSide = mainAxis === 'x' ? top : left;

    var _altSide = mainAxis === 'x' ? bottom : right;

    console.log(altAxis, _mainSide, overflow[_altSide]);
    state.offsets.popper[altAxis] = Math.max(Math.min(popperOffsets[altAxis], popperOffsets[altAxis] - overflow[_altSide]), popperOffsets[altAxis] + overflow[_mainSide]);
  }

  return state;
}
export default {
  name: 'flip',
  enabled: true,
  phase: 'main',
  fn: preventOverflow
};